(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./Attractor.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadParticlesAttractInteraction = loadParticlesAttractInteraction;
    const engine_1 = require("@tsparticles/engine");
    const Attractor_js_1 = require("./Attractor.js");
    async function loadParticlesAttractInteraction(engine, refresh = true) {
        (0, engine_1.assertValidVersion)(engine, "3.7.1");
        await engine.addInteractor("particlesAttract", container => {
            return Promise.resolve(new Attractor_js_1.Attractor(container));
        }, refresh);
    }
});
